/*
	alliance.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include "system.h"
#include "defs.h"
#include "public.h"
#include "config.h"

ali alis[ALICOUNT]; //Alliance database

void initalis()
{
	short cnt; //Alliance count

	cnt=0;
	setquick(false);
	for(short i=0;i<ALICOUNT;i++)
	{
		alis[i].self=i;
		alis[i].spw=false;
		alis[i].load();
		if(alis[i].nam[0]!='\0')
			cnt++;
	}
	if(cnt==0)
		quit("Initialisation error: no universe to build");
}

void inituniverse()
{
	long sx,sy; //Seed co-ordinates
	for(short i=0;i<ALICOUNT;i++)
	{
		if(alis[i].nam[0]!='\0')
		{
			sx=2*(rnd(LIMIT*2)-LIMIT)/3;
			sy=2*(rnd(LIMIT*2)-LIMIT)/3;
			for(short j=0;j<alis[i].nsys;j++)
			{
				newsystem(sx+rnd(LIMIT/2)-LIMIT/4,sy+rnd(LIMIT/2)-LIMIT/4,i);
			}
		}
	}
}

bool opposes(short a,short b)
{
	if(a==-1 || b==-1)
		return false;
	if(alis[a].grp!=alis[b].grp)
		return true;
	else
		return false;
}

ali* getali(short indx)
{
	return &alis[indx];

}

void ali::load()
{
	char* path; //Path to load equipment data from
	FILE* strm;  //Filestream to use
	char atsc[33]; //Attribute scratchpad
	
	memtest(path=new char[strlen(DATADIR)+32]);
	sprintf(path,"%s%salliances%s%hd.all",DATADIR,PATHSEP,PATHSEP,self);
	strm=fopen(path,"r");
	delete(path);
	if(strm!=NULL)
	{
		extractstring(strm,"Name",nam);
		grp=extractlong(strm,"Group");
		form=extractlong(strm,"Formation");
		flts=extractlong(strm,"FleetSize");
		aggr=extractlong(strm,"Aggression");
		defn=extractlong(strm,"Defence");
		cour=extractlong(strm,"Courage");
		nsys=extractlong(strm,"Systems");
		pinh=extractlong(strm,"PercentInhabited");
		wlth=extractlong(strm,"Wealth");
		ripo=extractlong(strm,"Ripoff");
		trad=extractlong(strm,"Trading");
		for(short i=0;i<16;i++)
		{
			sprintf(atsc,"Travel%hd",i);
			trav[i]=extractlong(strm,atsc);
		}
		for(short i=0;i<16;i++)
		{
			sprintf(atsc,"Ship%hd",i);
			sdns[i]=extractlong(strm,atsc);
		}
		for(short i=0;i<16;i++)
		{
			sprintf(atsc,"Equipment%hd",i);
			eqps[i]=extractlong(strm,atsc);
		}
		for(short i=0;i<16;i++)
		{
			sprintf(atsc,"CommString%hd",i);
			extractstring(strm,atsc,cmst[i]);
		}
		fclose((FILE*)strm);
	}
}

short ali::getspawn(long salt)
{
	if(spw)
		return sdns[prnd(16)];
	else
	{
		spw=true;
		return sdns[0];
	}
}
