/*
	dbase.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include "system.h"
#include "defs.h"
#include "public.h"

bool quik; //Quick (sequential) mode access?
char* extractgeneric(FILE* strm,char* attr); //Returns a pointer to the value of the named attribute from the given filestream Internal use only

char* extractgeneric(FILE* strm,char* attr)
{
	char sattr[33]; //Sample attribute
	char val[33]; //Value of extracted attribute
	char* out; //Output
	fpos_t pos,poss; //File markers
	bool fnd; //Found?
	
	memtest(out=new char[65]);
	out[0]='\0';
	fgetpos(strm,&pos);	
	fnd=false;
	while(!fnd)
	{
		fgetpos(strm,&poss);	
		if(fscanf(strm,"%33s = %33s\n",sattr,val)==EOF)
			fnd=true;
		if(strcmp(attr,sattr)==0)
		{
			strcpy(out,val);
			fnd=true;			
		}
		else
		{
			if(strcmp(sattr,"Object")==0)
			{
				fsetpos(strm,&poss);
				fnd=true;
			}
		}
	}
	if(!quik)	
		fsetpos(strm,&pos);
	return out;	
}

long extractlong(FILE* strm,char* attr)
{
	char* proc; //String to process
	long out; //Output
	
	proc=extractgeneric((FILE*)strm,attr);
	out=-1;
	sscanf(proc,"%ld",&out);
	delete(proc);
	return out;
}

void extractstring(FILE* strm,char* attr,char* put)
{
	char* proc; //String to process
	
	proc=extractgeneric((FILE*)strm,attr);
	strcpy(put,proc);
	delete(proc);
}

void gotoobject(FILE* strm,char* nam)
{
	char samp[65]; //Sample object name
	char err[128]; //Error string
	
	extractstring(strm,"Object",samp);
	if(strcmp(samp,nam)==0)
	{
		return;
	}
	else
	{
		sprintf(err,"DBase error: Object %s not found or out of sequence",nam);
		quit(err);
	}
}

void setquick(bool set)
{
	quik=set;
}
