/*
	equip.cpp
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

#include "system.h"
#include "defs.h"
#include "public.h"
#include "config.h"

equip equips[EQUIPCOUNT]; //Equipment database

void initequip()
{
	setquick(false);
	for(short i=0;i<EQUIPCOUNT;i++)
	{
		equips[i].self=i;
		equips[i].load();
	}
}

equip* getequip(short indx)
{
	return &equips[indx];
}

void manifest(ship* mine)
{
	char txt[65],txt2[65],txt3[65]; //Scratchpad
	bool fuse; //Flag to denote first used slots being found
	bool ffre; //Flag to denote first free external slots being found
	
	fuse=false;
	ffre=false;
	for(short i=0;i<32;i++)
	{
		txt[0]=0;
		if(mine->slots[i].indx!=-1)
		{
			if(!fuse)
				sprintf(txt3,">%s<",equips[mine->slots[i].indx].nam);
			else
				sprintf(txt3," %s ",equips[mine->slots[i].indx].nam);
			fuse=true;
			if(mine->slots[i].rdy!=0)
				if(mine->slots[i].rdy%2==0)
					sprintf(txt2,"%s/",txt3);
				else
					sprintf(txt2,"%s\\",txt3);
			else
				sprintf(txt2,"%s ",txt3);
			if(mine->slots[i].cap>0)
			{
				sprintf(txt,"%s[%hd]",txt2,mine->slots[i].cap);
				printcons(txt);
			}
			else
			{
				printcons(txt2);
			}
		}
		else
		{
			if(mine->slots[i].pos.rad!=-1)
			{
				if(mine->slots[i].face<=90 || mine->slots[i].face>=270)
					sprintf(txt2,"[Free forward external]");
				else
					sprintf(txt2,"[Free rear external]");
				if(!ffre)
					sprintf(txt,">%s<",txt2);
				else
					sprintf(txt," %s ",txt2);
				printcons(txt);
				ffre=true;
			}
		}
	}
}


void equip::load()
{
	char* path; //Path to load equipment data from
	FILE* strm;  //Filestream to use
	
	memtest(path=new char[strlen(DATADIR)+32]);
	sprintf(path,"%s%sequip%s%hd.eqp",DATADIR,PATHSEP,PATHSEP,self);
	strm=fopen(path,"r");
	delete(path);
	if(strm!=NULL)
	{
		extractstring(strm,"Name",nam);
		typ=extractlong(strm,"Type");
		mss=extractlong(strm,"Mass");
		spr=extractlong(strm,"Sprite");
		snd=extractlong(strm,"Sound");
		pow=extractlong(strm,"Power");
		rdy=extractlong(strm,"CycleTime");
		cap=extractlong(strm,"Capacity");
		rng=extractlong(strm,"Range");
		trck=extractlong(strm,"Tracking");
		acov=extractlong(strm,"Coverage");
		cost=extractlong(strm,"Cost");
		fclose(strm);
	}
}
