/*
	public.h
	
	(c) Richard Thrippleton, July 2001
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

vct poltovct(pol in,bool hres); //Converts a polar to a vector. High res mode?
pol vcttopol(vct in); //Converts a vector to a polar
long quickroot(long x); //Computes the square root of x
long rnd(long max); //Returns a random number from 0 to max
long prnd(long max); //Returns a predictable random number from 0 to max
char* getspeed(long spd); //Returns a given speed as an appropriate string

short newship(short indx,long x,long y,short all); //Creates a new ship, returning its index
ship* getship(short indx); //Returns a pointer to the given ship
void radarships(long povx,long povy,long rng,short comm); //Draw ships on radar with given point of view and radar range, also ship that messaged you
short retargetships(ship* mine,short typ); //Toggle user's target (typ: 1 - Any  2 - Enemy)
short startme(short all); //Return an appropriate ship to start with in the given alliance
void saveships(FILE* strm); //Saves all the ships to a given filestream
void loadships(FILE* strm); //Load all the ships from a given filestream
void armageddon(short indx);

equip* getequip(short indx); //Returns a pointer to equipment item indx
void manifest(ship* mine); //Prints out an equipment manifest of your ship (given)

planet* getplanet(short indx); //Returns planet of given index
void radarplanets(long povx,long povy,long rng,short trg); //Draw planets on radar with given point of view, radar range and target
short retargetplanets(ship* mine,short typ); //Toggle user's planetary target (typ: 1 - Nearbye bodies 2 - Long range systems)
void saveplanets(FILE* strm); //Saves all the planets to a given filestream
void loadplanets(FILE* strm); //Load all the planets from a given filestream

void newsystem(long x,long y,short all); //Creates a new star system at the given position with given alliance
void starchart(long povx,long povy,short trg); //Draws a starchart on the console, hilighting the ship (at pov)
short goodplanet(short all); //Returns a suitable planet to travel to, given all the alliance
short mlckcheck(long x,long y); //Returns whether or not the given position is planet mass-locked
void shipyard(short indx); //Spawns ships at given planet

bool opposes(short a,short b); //Is alliance a opposed to alliance b?
ali* getali(short indx); //Return a pointer to given index of alliances

void newfrag(frag* in); //Creates a new frag
void radarfrags(long povx,long povy,long rng); //Draw frags on radar with given point of view and radar range
void purgefrags(short trg); //Purges target of all frags targetted on trg
void savefrags(FILE* strm); //Saves all the frags to a given filestream
void loadfrags(FILE* strm); //Load all the frags from a given filestream

void string(char* str,short x,short y); //Prints a string at the given co-ordinates
void drawsprite(short indx,short x,short y,short rot,short mode); //Public wrapper to draw sprite of given index
void box(long x,long y,long w,long h,short col); //Draw a box, colour given using own colour lookup table
void getspritedims(short indx,short rot,short mode,short* hw,short* hh); //Returns the hw and hh dimensions of a given sprite
void clip(short x,short y,short w,short h); //Wrapper for ClipRect
void pix(long x,long y,short col); //Draws a pixel at given co-ordinates

void setquick(bool set); //Set quick mode (see bool quik def in dbase.cpp)
long extractlong(FILE* strm,char* attr); //Extracts the integer value of the named attribute from the given filestream
void extractstring(FILE* strm,char* attr,char* put); //Puts the value of attribute attr into put
void gotoobject(FILE* strm,char* nam); //Jumps to the point in the given stream ready to read the object of given name

void debug(const char* str,long num); //Reports a debugging string
void memtest(void* ptr); //Asserts that the given pointer isn't NULL (use for wrapping around 'new' calls)
void sdlnulltest(void* test); //Give it the pointer to an SDL surface you've just tried to make, and it will terminate the program if there's a problem

void playsound(short indx,short div); //Plays a sound of the given index at given div factor
bool togglesound(); //Toggles sound output on and off. Returns sound device status afterwards

bool see(long x,long y); //Can you see the given co-ordinates?
void printcons(char* text); //Write text to the console
void spritecons(short indx); //Draws a sprite in the console of given index
void getreal(long x,long y,long* ax,long* ay); //Gives the actual screen position
void message(ship* frm,short str); //Send a message from the given ship with given string index
void quickmessage(char* txt); //Immediate quick and dirty message
void noise(long x,long y,short indx); //Emit noise at following co-ordinates, sound index given
void shakeme(short pow); //Shake with given power

void quit(char* msg); //Quit with the given message
void savegame(); //Saves the entire game
void loadgame(); //Loads an entire game

const long LIMIT=100000000; //Bounds of the universe
